Index: branches/UKMO/AMM15_v3_6_STABLE_package_collate_BGC_DA/NEMOGCM/NEMO/OPA_SRC/ASM/asmbgc.F90
===================================================================
--- branches/UKMO/AMM15_v3_6_STABLE_package_collate_BGC_DA/NEMOGCM/NEMO/OPA_SRC/ASM/asmbgc.F90	(revision 10574)
+++ branches/UKMO/AMM15_v3_6_STABLE_package_collate_BGC_DA/NEMOGCM/NEMO/OPA_SRC/ASM/asmbgc.F90	(revision 10622)
@@ -787,42 +1027,150 @@
       !!------------------------------------------------------------------------
       !!
-      INTEGER, INTENT(in   ) :: kt     ! Current time-step
-      INTEGER, INTENT(in   ) :: knum   ! i/o unit of increments file
-      !!
-      !!------------------------------------------------------------------------
-
+      INTEGER,  INTENT(in   ) :: kt               ! Current time-step
+      !!
+      REAL(wp), INTENT(in   ) :: pnumtimes_tavg   ! No of times to average over
+      !!
+      !!------------------------------------------------------------------------
+      
+      IF (kt == nittrc000) THEN
+         pgrow_avg_tavg(:,:) = 0.0
+         ploss_avg_tavg(:,:) = 0.0
+         phyt_avg_tavg(:,:)  = 0.0
+         trn_tavg(:,:,:,:)   = 0.0
 #if defined key_hadocc
-      CALL iom_rstput( kt, nitbkg_r, knum, 'pgrow_avg'   , pgrow_avg             )
-      CALL iom_rstput( kt, nitbkg_r, knum, 'ploss_avg'   , ploss_avg             )
-      CALL iom_rstput( kt, nitbkg_r, knum, 'phyt_avg'    , phyt_avg              )
-      CALL iom_rstput( kt, nitbkg_r, knum, 'mld_max'     , mld_max               )
-      CALL iom_rstput( kt, nitbkg_r, knum, 'hadocc_nut'  , trn(:,:,:,jp_had_nut) )
-      CALL iom_rstput( kt, nitbkg_r, knum, 'hadocc_phy'  , trn(:,:,:,jp_had_phy) )
-      CALL iom_rstput( kt, nitbkg_r, knum, 'hadocc_zoo'  , trn(:,:,:,jp_had_zoo) )
-      CALL iom_rstput( kt, nitbkg_r, knum, 'hadocc_pdn'  , trn(:,:,:,jp_had_pdn) )
-      CALL iom_rstput( kt, nitbkg_r, knum, 'hadocc_dic'  , trn(:,:,:,jp_had_dic) )
-      CALL iom_rstput( kt, nitbkg_r, knum, 'hadocc_alk'  , trn(:,:,:,jp_had_alk) )
-      CALL iom_rstput( kt, nitbkg_r, knum, 'hadocc_chl'  , HADOCC_CHL(:,:,:)     )
-      CALL iom_rstput( kt, nitbkg_r, knum, 'hadocc_cchl' , cchl_p(:,:,:)         )
+         HADOCC_CHL_tavg(:,:,:) = 0.0
+         cchl_p_tavg(:,:,:)     = 0.0
+#elif defined key_fabm
+         totalk_tavg(:,:,:)  = 0.0
+#endif
+      ENDIF
+      
+      pgrow_avg_tavg(:,:) = pgrow_avg_tavg(:,:) + pgrow_avg(:,:) / pnumtimes_tavg
+      ploss_avg_tavg(:,:) = ploss_avg_tavg(:,:) + ploss_avg(:,:) / pnumtimes_tavg
+      phyt_avg_tavg(:,:)  = phyt_avg_tavg(:,:)  + phyt_avg(:,:)  / pnumtimes_tavg
+      trn_tavg(:,:,:,:)   = trn_tavg(:,:,:,:)   + trn(:,:,:,:)   / pnumtimes_tavg
+#if defined key_hadocc
+      HADOCC_CHL_tavg(:,:,:) = HADOCC_CHL_tavg(:,:,:) + HADOCC_CHL(:,:,:) / pnumtimes_tavg
+      cchl_p_tavg(:,:,:)     = cchl_p_tavg(:,:,:)     + cchl_p(:,:,:)     / pnumtimes_tavg
+#elif defined key_fabm
+      totalk_tavg(:,:,:)  = totalk_tavg(:,:,:) + &
+         &                  fabm_get_interior_diagnostic_data(model, jp_fabm_o3ta) / pnumtimes_tavg
+      totalk_tavg(:,:,:)  = totalk_tavg(:,:,:) * tmask(:,:,:)
+#endif
+                                 
+   END SUBROUTINE asm_bgc_bkg_tavg
+
+   !!===========================================================================
+   !!===========================================================================
+   !!===========================================================================
+
+   SUBROUTINE asm_bgc_bkg_wri( kt, knum, ld_avgbkg )
+      !!------------------------------------------------------------------------
+      !!                    ***  ROUTINE asm_bgc_bkg_wri  ***
+      !!
+      !! ** Purpose :   write out bgc background
+      !!
+      !! ** Method  :   write out bgc background
+      !!
+      !! ** Action  :   write out bgc background
+      !!
+      !! References :   asm_bkg_wri
+      !!------------------------------------------------------------------------
+      !!
+      INTEGER, INTENT(in   ) :: kt          ! Current time-step
+      INTEGER, INTENT(in   ) :: knum        ! i/o unit of increments file
+      LOGICAL, INTENT(in   ) :: ld_avgbkg   ! Averaged background?
+      !!
+      INTEGER                :: nitbgcbkg_r ! Period referenced to nit000
+      !!
+      !!------------------------------------------------------------------------
+      
+      IF (ld_avgbkg) THEN
+         nitbgcbkg_r = nitavgbkg_r
+      ELSE
+         nitbgcbkg_r = nitbkg_r
+         pgrow_avg_tavg(:,:) = pgrow_avg(:,:)
+         ploss_avg_tavg(:,:) = ploss_avg(:,:)
+         phyt_avg_tavg(:,:)  = phyt_avg(:,:)
+         trn_tavg(:,:,:,:)   = trn(:,:,:,:)
+#if defined key_hadocc
+         HADOCC_CHL_tavg(:,:,:) = HADOCC_CHL(:,:,:)
+         cchl_p_tavg(:,:,:)     = cchl_p(:,:,:)
+#elif defined key_fabm
+         totalk_tavg(:,:,:)  = fabm_get_interior_diagnostic_data(model, jp_fabm_o3ta)
+         totalk_tavg(:,:,:)  = totalk_tavg(:,:,:) * tmask(:,:,:)
+#endif
+      ENDIF
+
+#if defined key_hadocc
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'pgrow_avg'   , pgrow_avg_tavg             )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ploss_avg'   , ploss_avg_tavg             )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'phyt_avg'    , phyt_avg_tavg              )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'mld_max'     , mld_max                    )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'hadocc_nut'  , trn_tavg(:,:,:,jp_had_nut) )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'hadocc_phy'  , trn_tavg(:,:,:,jp_had_phy) )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'hadocc_zoo'  , trn_tavg(:,:,:,jp_had_zoo) )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'hadocc_pdn'  , trn_tavg(:,:,:,jp_had_pdn) )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'hadocc_dic'  , trn_tavg(:,:,:,jp_had_dic) )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'hadocc_alk'  , trn_tavg(:,:,:,jp_had_alk) )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'hadocc_chl'  , HADOCC_CHL(:,:,:)     )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'hadocc_cchl' , cchl_p(:,:,:)         )
 #elif defined key_medusa
-      CALL iom_rstput( kt, nitbkg_r, knum, 'pgrow_avg'   , pgrow_avg        )
-      CALL iom_rstput( kt, nitbkg_r, knum, 'ploss_avg'   , ploss_avg        )
-      CALL iom_rstput( kt, nitbkg_r, knum, 'phyt_avg'    , phyt_avg         )
-      CALL iom_rstput( kt, nitbkg_r, knum, 'mld_max'     , mld_max          )
-      CALL iom_rstput( kt, nitbkg_r, knum, 'medusa_chn'  , trn(:,:,:,jpchn) )
-      CALL iom_rstput( kt, nitbkg_r, knum, 'medusa_chd'  , trn(:,:,:,jpchd) )
-      CALL iom_rstput( kt, nitbkg_r, knum, 'medusa_phn'  , trn(:,:,:,jpphn) )
-      CALL iom_rstput( kt, nitbkg_r, knum, 'medusa_phd'  , trn(:,:,:,jpphd) )
-      CALL iom_rstput( kt, nitbkg_r, knum, 'medusa_pds'  , trn(:,:,:,jppds) )
-      CALL iom_rstput( kt, nitbkg_r, knum, 'medusa_zmi'  , trn(:,:,:,jpzmi) )
-      CALL iom_rstput( kt, nitbkg_r, knum, 'medusa_zme'  , trn(:,:,:,jpzme) )
-      CALL iom_rstput( kt, nitbkg_r, knum, 'medusa_din'  , trn(:,:,:,jpdin) )
-      CALL iom_rstput( kt, nitbkg_r, knum, 'medusa_sil'  , trn(:,:,:,jpsil) )
-      CALL iom_rstput( kt, nitbkg_r, knum, 'medusa_fer'  , trn(:,:,:,jpfer) )
-      CALL iom_rstput( kt, nitbkg_r, knum, 'medusa_det'  , trn(:,:,:,jpdet) )
-      CALL iom_rstput( kt, nitbkg_r, knum, 'medusa_dtc'  , trn(:,:,:,jpdtc) )
-      CALL iom_rstput( kt, nitbkg_r, knum, 'medusa_dic'  , trn(:,:,:,jpdic) )
-      CALL iom_rstput( kt, nitbkg_r, knum, 'medusa_alk'  , trn(:,:,:,jpalk) )
-      CALL iom_rstput( kt, nitbkg_r, knum, 'medusa_oxy'  , trn(:,:,:,jpoxy) )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'pgrow_avg'   , pgrow_avg_tavg        )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ploss_avg'   , ploss_avg_tavg        )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'phyt_avg'    , phyt_avg_tavg         )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'mld_max'     , mld_max               )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'medusa_chn'  , trn_tavg(:,:,:,jpchn) )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'medusa_chd'  , trn_tavg(:,:,:,jpchd) )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'medusa_phn'  , trn_tavg(:,:,:,jpphn) )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'medusa_phd'  , trn_tavg(:,:,:,jpphd) )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'medusa_pds'  , trn_tavg(:,:,:,jppds) )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'medusa_zmi'  , trn_tavg(:,:,:,jpzmi) )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'medusa_zme'  , trn_tavg(:,:,:,jpzme) )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'medusa_din'  , trn_tavg(:,:,:,jpdin) )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'medusa_sil'  , trn_tavg(:,:,:,jpsil) )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'medusa_fer'  , trn_tavg(:,:,:,jpfer) )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'medusa_det'  , trn_tavg(:,:,:,jpdet) )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'medusa_dtc'  , trn_tavg(:,:,:,jpdtc) )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'medusa_dic'  , trn_tavg(:,:,:,jpdic) )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'medusa_alk'  , trn_tavg(:,:,:,jpalk) )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'medusa_oxy'  , trn_tavg(:,:,:,jpoxy) )
+#elif defined key_fabm
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'pgrow_avg'   , pgrow_avg_tavg               )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ploss_avg'   , ploss_avg_tavg               )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'phyt_avg'    , phyt_avg_tavg                )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'mld_max'     , mld_max                      )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_chl1'  , trn_tavg(:,:,:,jp_fabm_chl1) )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_chl2'  , trn_tavg(:,:,:,jp_fabm_chl2) )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_chl3'  , trn_tavg(:,:,:,jp_fabm_chl3) )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_chl4'  , trn_tavg(:,:,:,jp_fabm_chl4) )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_p1c'   , trn_tavg(:,:,:,jp_fabm_p1c)  )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_p1n'   , trn_tavg(:,:,:,jp_fabm_p1n)  )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_p1p'   , trn_tavg(:,:,:,jp_fabm_p1p)  )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_p1s'   , trn_tavg(:,:,:,jp_fabm_p1s)  )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_p2c'   , trn_tavg(:,:,:,jp_fabm_p2c)  )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_p2n'   , trn_tavg(:,:,:,jp_fabm_p2n)  )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_p2p'   , trn_tavg(:,:,:,jp_fabm_p2p)  )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_p3c'   , trn_tavg(:,:,:,jp_fabm_p3c)  )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_p3n'   , trn_tavg(:,:,:,jp_fabm_p3n)  )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_p3p'   , trn_tavg(:,:,:,jp_fabm_p3p)  )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_p4c'   , trn_tavg(:,:,:,jp_fabm_p4c)  )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_p4n'   , trn_tavg(:,:,:,jp_fabm_p4n)  )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_p4p'   , trn_tavg(:,:,:,jp_fabm_p4p)  )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_z4c'   , trn_tavg(:,:,:,jp_fabm_z4c)  )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_z5c'   , trn_tavg(:,:,:,jp_fabm_z5c)  )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_z5n'   , trn_tavg(:,:,:,jp_fabm_z5n)  )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_z5p'   , trn_tavg(:,:,:,jp_fabm_z5p)  )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_z6c'   , trn_tavg(:,:,:,jp_fabm_z6c)  )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_z6n'   , trn_tavg(:,:,:,jp_fabm_z6n)  )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_z6p'   , trn_tavg(:,:,:,jp_fabm_z6p)  )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_n1p'   , trn_tavg(:,:,:,jp_fabm_n1p)  )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_n3n'   , trn_tavg(:,:,:,jp_fabm_n3n)  )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_n4n'   , trn_tavg(:,:,:,jp_fabm_n4n)  )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_n5s'   , trn_tavg(:,:,:,jp_fabm_n5s)  )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_o2o'   , trn_tavg(:,:,:,jp_fabm_o2o)  )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_o3c'   , trn_tavg(:,:,:,jp_fabm_o3c)  )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_o3ba'  , trn_tavg(:,:,:,jp_fabm_o3ba) )
+      CALL iom_rstput( kt, nitbgcbkg_r, knum, 'ersem_o3ta'  , totalk_tavg                  )
 #endif
 
@@ -911,4 +1259,13 @@
       REAL(wp), DIMENSION(jpi,jpj) :: zinc_phynon ! Local phynon incs
       REAL(wp), DIMENSION(jpi,jpj) :: zbkg_phynon ! Local phynon bkg
+#elif defined key_fabm
+      REAL(wp), DIMENSION(jpi,jpj) :: zinc_chldia ! Local chldia incs
+      REAL(wp), DIMENSION(jpi,jpj) :: zbkg_chldia ! Local chldia bkg
+      REAL(wp), DIMENSION(jpi,jpj) :: zinc_chldin ! Local chldin incs
+      REAL(wp), DIMENSION(jpi,jpj) :: zbkg_chldin ! Local chldin bkg
+      REAL(wp), DIMENSION(jpi,jpj) :: zinc_chlnan ! Local chlnan incs
+      REAL(wp), DIMENSION(jpi,jpj) :: zbkg_chlnan ! Local chlnan bkg
+      REAL(wp), DIMENSION(jpi,jpj) :: zinc_chlpic ! Local chlpic incs
+      REAL(wp), DIMENSION(jpi,jpj) :: zbkg_chlpic ! Local chlpic bkg
 #endif
       !!------------------------------------------------------------------------
@@ -926,4 +1283,9 @@
 #elif defined key_hadocc
             zbkg_chltot(:,:) = chl_bkg(:,:,1)
+#elif defined key_fabm
+            zbkg_chltot(:,:) = tracer_bkg(:,:,1,jp_fabm_chl1) + &
+               &               tracer_bkg(:,:,1,jp_fabm_chl2) + &
+               &               tracer_bkg(:,:,1,jp_fabm_chl3) + &
+               &               tracer_bkg(:,:,1,jp_fabm_chl4)
 #endif
             CALL asm_bgc_unlog_2d( zbkg_chltot, slchltot_bkginc, zinc_chltot )
@@ -934,8 +1296,12 @@
          ENDIF
 
-#if defined key_medusa
+#if defined key_medusa || defined key_fabm
          ! Diatom chlorophyll
          IF ( ln_slchldiainc ) THEN
+#if defined key_medusa
             zbkg_chldia(:,:) = tracer_bkg(:,:,1,jpchd)
+#elif defined key_fabm
+            zbkg_chldia(:,:) = tracer_bkg(:,:,1,jp_fabm_chl1)
+#endif
             CALL asm_bgc_unlog_2d( zbkg_chldia, slchldia_bkginc, zinc_chldia )
          ELSE
@@ -954,4 +1320,30 @@
 #endif
 
+#if defined key_fabm
+         ! Nanophytoplankton chlorophyll
+         IF ( ln_slchlnaninc ) THEN
+            zbkg_chlnan(:,:) = tracer_bkg(:,:,1,jp_fabm_chl2)
+            CALL asm_bgc_unlog_2d( zbkg_chlnan, slchlnan_bkginc, zinc_chlnan )
+         ELSE
+            zinc_chlnan(:,:) = 0.0
+         ENDIF
+
+         ! Picophytoplankton chlorophyll
+         IF ( ln_slchlpicinc ) THEN
+            zbkg_chlpic(:,:) = tracer_bkg(:,:,1,jp_fabm_chl3)
+            CALL asm_bgc_unlog_2d( zbkg_chlpic, slchlpic_bkginc, zinc_chlpic )
+         ELSE
+            zinc_chlpic(:,:) = 0.0
+         ENDIF
+
+         ! Dinoflagellate chlorophyll
+         IF ( ln_slchldininc ) THEN
+            zbkg_chldin(:,:) = tracer_bkg(:,:,1,jp_fabm_chl4)
+            CALL asm_bgc_unlog_2d( zbkg_chldin, slchldin_bkginc, zinc_chldin )
+         ELSE
+            zinc_chldin(:,:) = 0.0
+         ENDIF
+#endif
+
          ! Total phytoplankton carbon
          IF ( ln_slphytotinc ) THEN
@@ -988,5 +1380,5 @@
          ! Select mixed layer
          IF ( ll_asmdin ) THEN
-#if defined key_top && ( defined key_hadocc || defined key_medusa )
+#if defined key_top && ( defined key_hadocc || defined key_medusa || defined key_fabm )
             CALL ctl_warn( ' Doing direct initialisation with ocean colour assimilation', &
                &           ' Mixed layer depth taken to be background maximum mld_max_bkg' )
@@ -1014,7 +1406,5 @@
 #endif
             CASE ( 4 )                   ! Temperature criterion (0.2 K change from surface) [T points]
-               !zmld(:,:) = hmld_tref(:,:)
-               CALL ctl_stop( ' hmld_tref mixed layer requested for phyto2d assimilation,', &
-                  &           ' but is not available in this version' )
+               zmld(:,:) = hmld_tref(:,:)
             CASE ( 5 )                   ! Density criterion (0.01 kg/m^3 change from 10m) [T points]
                zmld(:,:) = hmlpt(:,:)
@@ -1053,4 +1443,21 @@
             &                         cchl_p_bkg(:,:,1),                   &
             &                         tracer_bkg, phyto2d_balinc )
+#elif defined key_fabm
+         CALL asm_phyto2d_bal_ersem(  (ln_slchltotinc .OR. ln_schltotinc), &
+            &                         zinc_chltot,                         &
+            &                         ln_slchldiainc,                      &
+            &                         zinc_chldia,                         &
+            &                         ln_slchlnaninc,                      &
+            &                         zinc_chlnan,                         &
+            &                         ln_slchlpicinc,                      &
+            &                         zinc_chlpic,                         &
+            &                         ln_slchldininc,                      &
+            &                         zinc_chldin,                         &
+            &                         zincper,                             &
+            &                         rn_maxchlinc, ln_phytobal, zmld,     &
+            &                         pgrow_avg_bkg, ploss_avg_bkg,        &
+            &                         phyt_avg_bkg, mld_max_bkg,           &
+            &                         totalk_bkg,                          &
+            &                         tracer_bkg, phyto2d_balinc )
 #else
          CALL ctl_stop( 'Attempting to assimilate phyto2d data, ', &
@@ -1098,4 +1505,12 @@
                   &                         phyto2d_balinc(:,:,:,jp_had0:jp_had1) * zincwgt
             END WHERE
+#elif defined key_fabm
+            WHERE( phyto2d_balinc(:,:,:,jp_fabm0:jp_fabm1) > 0.0_wp .OR. &
+               &   trn(:,:,:,jp_fabm0:jp_fabm1) + phyto2d_balinc(:,:,:,jp_fabm0:jp_fabm1) * zincwgt > 0.0_wp )
+               trn(:,:,:,jp_fabm0:jp_fabm1) = trn(:,:,:,jp_fabm0:jp_fabm1) + &
+                  &                           phyto2d_balinc(:,:,:,jp_fabm0:jp_fabm1) * zincwgt
+               trb(:,:,:,jp_fabm0:jp_fabm1) = trb(:,:,:,jp_fabm0:jp_fabm1) + &
+                  &                           phyto2d_balinc(:,:,:,jp_fabm0:jp_fabm1) * zincwgt
+            END WHERE
 #endif
 
@@ -1132,4 +1547,11 @@
                trb(:,:,:,jp_had0:jp_had1) = trn(:,:,:,jp_had0:jp_had1)
             END WHERE
+#elif defined key_fabm
+            WHERE( phyto2d_balinc(:,:,:,jp_fabm0:jp_fabm1) > 0.0_wp .OR. &
+               &   trn(:,:,:,jp_fabm0:jp_fabm1) + phyto2d_balinc(:,:,:,jp_fabm0:jp_fabm1) > 0.0_wp )
+               trn(:,:,:,jp_fabm0:jp_fabm1) = trn(:,:,:,jp_fabm0:jp_fabm1) + &
+                  &                           phyto2d_balinc(:,:,:,jp_fabm0:jp_fabm1)
+               trb(:,:,:,jp_fabm0:jp_fabm1) = trn(:,:,:,jp_fabm0:jp_fabm1)
+            END WHERE
 #endif
  
@@ -1163,14 +1585,31 @@
       REAL(wp), DIMENSION(kcycper), INTENT(IN) :: pwgtiau   ! IAU weights
       !
-      INTEGER                          :: ji, jj, jk   ! Loop counters
-      INTEGER                          :: it           ! Index
-      REAL(wp)                         :: zincwgt      ! IAU weight for timestep
-      REAL(wp)                         :: zfrac_chn    ! Fraction of jpchn
-      REAL(wp)                         :: zfrac_chd    ! Fraction of jpchd
-      REAL(wp)                         :: zrat_phn_chn ! jpphn:jpchn ratio
-      REAL(wp)                         :: zrat_phd_chd ! jpphd:jpchd ratio
-      REAL(wp)                         :: zrat_pds_chd ! jppds:jpchd ratio
-      REAL(wp), DIMENSION(jpi,jpj,jpk) :: chl_inc      ! Chlorophyll increments
-      REAL(wp), DIMENSION(jpi,jpj,jpk) :: bkg_chl      ! Chlorophyll background
+      INTEGER                          :: ji, jj, jk    ! Loop counters
+      INTEGER                          :: it            ! Index
+      REAL(wp)                         :: zincwgt       ! IAU weight for timestep
+      REAL(wp)                         :: zfrac_chn     ! Fraction of jpchn
+      REAL(wp)                         :: zfrac_chd     ! Fraction of jpchd
+      REAL(wp)                         :: zfrac_chl1    ! Fraction of jp_fabm_chl1
+      REAL(wp)                         :: zfrac_chl2    ! Fraction of jp_fabm_chl2
+      REAL(wp)                         :: zfrac_chl3    ! Fraction of jp_fabm_chl3
+      REAL(wp)                         :: zfrac_chl4    ! Fraction of jp_fabm_chl4
+      REAL(wp)                         :: zrat_phn_chn  ! jpphn:jpchn ratio
+      REAL(wp)                         :: zrat_phd_chd  ! jpphd:jpchd ratio
+      REAL(wp)                         :: zrat_pds_chd  ! jppds:jpchd ratio
+      REAL(wp)                         :: zrat_p1c_chl1 ! jp_fabm_p1c:jp_fabm_chl1 ratio
+      REAL(wp)                         :: zrat_p1n_chl1 ! jp_fabm_p1n:jp_fabm_chl1 ratio
+      REAL(wp)                         :: zrat_p1p_chl1 ! jp_fabm_p1p:jp_fabm_chl1 ratio
+      REAL(wp)                         :: zrat_p1s_chl1 ! jp_fabm_p1s:jp_fabm_chl1 ratio
+      REAL(wp)                         :: zrat_p2c_chl2 ! jp_fabm_p2c:jp_fabm_chl2 ratio
+      REAL(wp)                         :: zrat_p2n_chl2 ! jp_fabm_p2n:jp_fabm_chl2 ratio
+      REAL(wp)                         :: zrat_p2p_chl2 ! jp_fabm_p2p:jp_fabm_chl2 ratio
+      REAL(wp)                         :: zrat_p3c_chl3 ! jp_fabm_p3c:jp_fabm_chl3 ratio
+      REAL(wp)                         :: zrat_p3n_chl3 ! jp_fabm_p3n:jp_fabm_chl3 ratio
+      REAL(wp)                         :: zrat_p3p_chl3 ! jp_fabm_p3p:jp_fabm_chl3 ratio
+      REAL(wp)                         :: zrat_p4c_chl4 ! jp_fabm_p4c:jp_fabm_chl4 ratio
+      REAL(wp)                         :: zrat_p4n_chl4 ! jp_fabm_p4n:jp_fabm_chl4 ratio
+      REAL(wp)                         :: zrat_p4p_chl4 ! jp_fabm_p4p:jp_fabm_chl4 ratio
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: chl_inc       ! Chlorophyll increments
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: bkg_chl       ! Chlorophyll background
       !!------------------------------------------------------------------------
 
@@ -1189,4 +1628,9 @@
 #elif defined key_hadocc
             bkg_chl(:,:,:) = chl_bkg(:,:,:)
+#elif defined key_fabm
+            bkg_chl(:,:,:) = tracer_bkg(:,:,:,jp_fabm_chl1) + &
+               &             tracer_bkg(:,:,:,jp_fabm_chl2) + &
+               &             tracer_bkg(:,:,:,jp_fabm_chl3) + &
+               &             tracer_bkg(:,:,:,jp_fabm_chl4)
 #endif
             DO jk = 1, jpk
@@ -1240,4 +1684,51 @@
 #elif defined key_hadocc
          phyto3d_balinc(:,:,:,jp_had_phy) = ( cchl_p_bkg(:,:,:) / (mw_carbon * c2n_p) ) * chl_inc(:,:,:)
+#elif defined key_fabm
+         ! Loop over each grid point partioning the increments based on existing ratios
+         DO jk = 1, jpk
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  IF ( ( tracer_bkg(ji,jj,jk,jp_fabm_chl1) > 0.0 ) .AND. &
+                     & ( tracer_bkg(ji,jj,jk,jp_fabm_chl2) > 0.0 ) .AND. &
+                     & ( tracer_bkg(ji,jj,jk,jp_fabm_chl3) > 0.0 ) .AND. &
+                     & ( tracer_bkg(ji,jj,jk,jp_fabm_chl4) > 0.0 ) ) THEN
+                     zfrac_chl1 = tracer_bkg(ji,jj,jk,jp_fabm_chl1) / bkg_chl(ji,jj,jk)
+                     zfrac_chl2 = tracer_bkg(ji,jj,jk,jp_fabm_chl2) / bkg_chl(ji,jj,jk)
+                     zfrac_chl3 = tracer_bkg(ji,jj,jk,jp_fabm_chl3) / bkg_chl(ji,jj,jk)
+                     zfrac_chl4 = tracer_bkg(ji,jj,jk,jp_fabm_chl4) / bkg_chl(ji,jj,jk)
+                     phyto3d_balinc(ji,jj,jk,jp_fabm_chl1) = chl_inc(ji,jj,jk) * zfrac_chl1
+                     phyto3d_balinc(ji,jj,jk,jp_fabm_chl2) = chl_inc(ji,jj,jk) * zfrac_chl2
+                     phyto3d_balinc(ji,jj,jk,jp_fabm_chl3) = chl_inc(ji,jj,jk) * zfrac_chl3
+                     phyto3d_balinc(ji,jj,jk,jp_fabm_chl4) = chl_inc(ji,jj,jk) * zfrac_chl4
+                     zrat_p1c_chl1 = tracer_bkg(ji,jj,jk,jp_fabm_p1c) / tracer_bkg(ji,jj,jk,jp_fabm_chl1)
+                     zrat_p1n_chl1 = tracer_bkg(ji,jj,jk,jp_fabm_p1n) / tracer_bkg(ji,jj,jk,jp_fabm_chl1)
+                     zrat_p1p_chl1 = tracer_bkg(ji,jj,jk,jp_fabm_p1p) / tracer_bkg(ji,jj,jk,jp_fabm_chl1)
+                     zrat_p1s_chl1 = tracer_bkg(ji,jj,jk,jp_fabm_p1s) / tracer_bkg(ji,jj,jk,jp_fabm_chl1)
+                     zrat_p2c_chl2 = tracer_bkg(ji,jj,jk,jp_fabm_p2c) / tracer_bkg(ji,jj,jk,jp_fabm_chl2)
+                     zrat_p2n_chl2 = tracer_bkg(ji,jj,jk,jp_fabm_p2n) / tracer_bkg(ji,jj,jk,jp_fabm_chl2)
+                     zrat_p2p_chl2 = tracer_bkg(ji,jj,jk,jp_fabm_p2p) / tracer_bkg(ji,jj,jk,jp_fabm_chl2)
+                     zrat_p3c_chl3 = tracer_bkg(ji,jj,jk,jp_fabm_p3c) / tracer_bkg(ji,jj,jk,jp_fabm_chl3)
+                     zrat_p3n_chl3 = tracer_bkg(ji,jj,jk,jp_fabm_p3n) / tracer_bkg(ji,jj,jk,jp_fabm_chl3)
+                     zrat_p3p_chl3 = tracer_bkg(ji,jj,jk,jp_fabm_p3p) / tracer_bkg(ji,jj,jk,jp_fabm_chl3)
+                     zrat_p4c_chl4 = tracer_bkg(ji,jj,jk,jp_fabm_p4c) / tracer_bkg(ji,jj,jk,jp_fabm_chl4)
+                     zrat_p4n_chl4 = tracer_bkg(ji,jj,jk,jp_fabm_p4n) / tracer_bkg(ji,jj,jk,jp_fabm_chl4)
+                     zrat_p4p_chl4 = tracer_bkg(ji,jj,jk,jp_fabm_p4p) / tracer_bkg(ji,jj,jk,jp_fabm_chl4)
+                     phyto3d_balinc(ji,jj,jk,jp_fabm_p1c) = phyto3d_balinc(ji,jj,jk,jp_fabm_chl1) * zrat_p1c_chl1
+                     phyto3d_balinc(ji,jj,jk,jp_fabm_p1n) = phyto3d_balinc(ji,jj,jk,jp_fabm_chl1) * zrat_p1n_chl1
+                     phyto3d_balinc(ji,jj,jk,jp_fabm_p1p) = phyto3d_balinc(ji,jj,jk,jp_fabm_chl1) * zrat_p1p_chl1
+                     phyto3d_balinc(ji,jj,jk,jp_fabm_p1s) = phyto3d_balinc(ji,jj,jk,jp_fabm_chl1) * zrat_p1s_chl1
+                     phyto3d_balinc(ji,jj,jk,jp_fabm_p2c) = phyto3d_balinc(ji,jj,jk,jp_fabm_chl2) * zrat_p2c_chl2
+                     phyto3d_balinc(ji,jj,jk,jp_fabm_p2n) = phyto3d_balinc(ji,jj,jk,jp_fabm_chl2) * zrat_p2n_chl2
+                     phyto3d_balinc(ji,jj,jk,jp_fabm_p2p) = phyto3d_balinc(ji,jj,jk,jp_fabm_chl2) * zrat_p2p_chl2
+                     phyto3d_balinc(ji,jj,jk,jp_fabm_p3c) = phyto3d_balinc(ji,jj,jk,jp_fabm_chl3) * zrat_p3c_chl3
+                     phyto3d_balinc(ji,jj,jk,jp_fabm_p3n) = phyto3d_balinc(ji,jj,jk,jp_fabm_chl3) * zrat_p3n_chl3
+                     phyto3d_balinc(ji,jj,jk,jp_fabm_p3p) = phyto3d_balinc(ji,jj,jk,jp_fabm_chl3) * zrat_p3p_chl3
+                     phyto3d_balinc(ji,jj,jk,jp_fabm_p4c) = phyto3d_balinc(ji,jj,jk,jp_fabm_chl4) * zrat_p4c_chl4
+                     phyto3d_balinc(ji,jj,jk,jp_fabm_p4n) = phyto3d_balinc(ji,jj,jk,jp_fabm_chl4) * zrat_p4n_chl4
+                     phyto3d_balinc(ji,jj,jk,jp_fabm_p4p) = phyto3d_balinc(ji,jj,jk,jp_fabm_chl4) * zrat_p4p_chl4
+                  ENDIF
+               END DO
+            END DO
+         END DO
 #else
          CALL ctl_stop( 'Attempting to assimilate p(l)chltot, ', &
@@ -1285,4 +1776,12 @@
                   &                         phyto3d_balinc(:,:,:,jp_had0:jp_had1) * zincwgt
             END WHERE
+#elif defined key_fabm
+            WHERE( phyto3d_balinc(:,:,:,jp_fabm0:jp_fabm1) > 0.0_wp .OR. &
+               &   trn(:,:,:,jp_fabm0:jp_fabm1) + phyto3d_balinc(:,:,:,jp_fabm0:jp_fabm1) * zincwgt > 0.0_wp )
+               trn(:,:,:,jp_fabm0:jp_fabm1) = trn(:,:,:,jp_fabm0:jp_fabm1) + &
+                  &                           phyto3d_balinc(:,:,:,jp_fabm0:jp_fabm1) * zincwgt
+               trb(:,:,:,jp_fabm0:jp_fabm1) = trb(:,:,:,jp_fabm0:jp_fabm1) + &
+                  &                           phyto3d_balinc(:,:,:,jp_fabm0:jp_fabm1) * zincwgt
+            END WHERE
 #endif
 
@@ -1318,4 +1817,11 @@
                   &                         phyto3d_balinc(:,:,:,jp_had0:jp_had1)
                trb(:,:,:,jp_had0:jp_had1) = trn(:,:,:,jp_had0:jp_had1)
+            END WHERE
+#elif defined key_fabm
+            WHERE( phyto3d_balinc(:,:,:,jp_fabm0:jp_fabm1) > 0.0_wp .OR. &
+               &   trn(:,:,:,jp_fabm0:jp_fabm1) + phyto3d_balinc(:,:,:,jp_fabm0:jp_fabm1) > 0.0_wp )
+               trn(:,:,:,jp_fabm0:jp_fabm1) = trn(:,:,:,jp_fabm0:jp_fabm1) + &
+                  &                           phyto3d_balinc(:,:,:,jp_fabm0:jp_fabm1)
+               trb(:,:,:,jp_fabm0:jp_fabm1) = trn(:,:,:,jp_fabm0:jp_fabm1)
             END WHERE
 #endif
@@ -1447,4 +1953,18 @@
             &               pco2_balinc(:,:,1,jp_had_dic), pco2_balinc(:,:,1,jp_had_alk) )
 
+#elif defined key_fabm
+         ! Account for phytoplankton balancing if required
+         IF ( ln_phytobal ) THEN
+            dic_bkg_temp(:,:) = tracer_bkg(:,:,1,jp_fabm_o3c) + phyto2d_balinc(:,:,1,jp_fabm_o3c)
+            alk_bkg_temp(:,:) = totalk_bkg(:,:,1)             + phyto2d_balinc(:,:,1,jp_fabm_o3ba)
+         ELSE
+            dic_bkg_temp(:,:) = tracer_bkg(:,:,1,jp_fabm_o3c)
+            alk_bkg_temp(:,:) = totalk_bkg(:,:,1)
+         ENDIF
+
+         CALL asm_pco2_bal( pco2_bkginc_temp(:,:), dic_bkg_temp(:,:), alk_bkg_temp(:,:), &
+            &               tem_bkg_temp(:,:), sal_bkg_temp(:,:),                        &
+            &               pco2_balinc(:,:,1,jp_fabm_o3c), pco2_balinc(:,:,1,jp_fabm_o3ba) )
+
 #else
          CALL ctl_stop( 'Attempting to assimilate pCO2/fCO2, ', &
@@ -1454,5 +1974,5 @@
          ! Select mixed layer
          IF ( ll_asmdin ) THEN
-#if defined key_hadocc || defined key_medusa
+#if defined key_hadocc || defined key_medusa || defined key_fabm
             CALL ctl_warn( ' Doing direct initialisation with pCO2 assimilation', &
                &           ' Mixed layer depth taken to be background maximum mld_max_bkg' )
@@ -1480,7 +2000,5 @@
 #endif
             CASE ( 4 )                   ! Temperature criterion (0.2 K change from surface) [T points]
-               !zmld(:,:) = hmld_tref(:,:)
-               CALL ctl_stop( ' hmld_tref mixed layer requested for pCO2 assimilation,', &
-                  &           ' but is not available in this version' )
+               zmld(:,:) = hmld_tref(:,:)
             CASE ( 5 )                   ! Density criterion (0.01 kg/m^3 change from 10m) [T points]
                zmld(:,:) = hmlpt(:,:)
@@ -1555,4 +2073,12 @@
                   &                         pco2_balinc(:,:,:,jp_had0:jp_had1) * zincwgt
             END WHERE
+#elif defined key_fabm
+            WHERE( pco2_balinc(:,:,:,jp_fabm0:jp_fabm1) > 0.0_wp .OR. &
+               &   trn(:,:,:,jp_fabm0:jp_fabm1) + pco2_balinc(:,:,:,jp_fabm0:jp_fabm1) * zincwgt > 0.0_wp )
+               trn(:,:,:,jp_fabm0:jp_fabm1) = trn(:,:,:,jp_fabm0:jp_fabm1) + &
+                  &                           pco2_balinc(:,:,:,jp_fabm0:jp_fabm1) * zincwgt
+               trb(:,:,:,jp_fabm0:jp_fabm1) = trb(:,:,:,jp_fabm0:jp_fabm1) + &
+                  &                           pco2_balinc(:,:,:,jp_fabm0:jp_fabm1) * zincwgt
+            END WHERE
 #endif
 
